#include "buttons.h"



void set_config_hislen( FL_OBJECT *obj, long argument ){
	history_length = atoi(fl_get_input(c_hislen_text));
	if(history_length < 1) history_length = 1;
	while(history_length < fl_get_browser_maxline(i_list)) fl_delete_browser_line(i_list, 1);
}
void set_config_sabove( FL_OBJECT *obj, long argument ){
	stack_above = atoi(fl_get_input(c_sabove_text));
	if(stack_above < 0) stack_above = 0;
	update_stack();
}
void set_config_sbelow( FL_OBJECT *obj, long argument ){
	stack_below = atoi(fl_get_input(c_sbelow_text));
	if(stack_below < 0) stack_below = 0;
	update_stack();
}
void set_config_steplock( FL_OBJECT *obj, long argument ){
	steplock_time = atoi(fl_get_input(c_steplock_text));
	if(steplock_time < 1) steplock_time = 1;
}
void set_config_nextlock( FL_OBJECT *obj, long argument ){
	nextlock_time = atoi(fl_get_input(c_nextlock_text));
	if(nextlock_time < 1) nextlock_time = 1;
}


void ConfirmQuit( ){
	fl_show_form(quitConfirm,FL_PLACE_MOUSE,FL_NOBORDER,"Quit?");
	while(1){
		event = fl_do_forms();
		if(event==yes)		quit();
		if(event==no){		fl_hide_form(quitConfirm); return; }
	}
}


void show_structure( FL_OBJECT *obj, long argument ){
	char temp_string[200];
	int s;

	s = fl_get_browser(st_list) - 1;

	if(memlist[s].window == NULL){
		memlist[s].window = fl_bgn_form(FL_FLAT_BOX, 400, 300);

		memlist[s].table = fl_add_browser(FL_HOLD_BROWSER,            5,   5, 390, 264, NULL);
		fl_set_object_lstyle(memlist[s].table, FL_FIXED_STYLE);
		fl_set_object_gravity(memlist[s].table, FL_NorthWest, FL_SouthEast);
		fl_set_object_resize(memlist[s].table, FL_RESIZE_ALL);



		memlist[s].start_text = fl_add_input(FL_NORMAL_INPUT,   35, 270,  50,  25, "Start");
		fl_set_input_maxchars(memlist[s].start_text, 8);
		fl_set_object_lstyle(memlist[s].start_text, FL_BOLD_STYLE);
		fl_set_object_gravity(memlist[s].start_text, FL_SouthEast, FL_SouthEast);
		fl_set_object_resize(memlist[s].start_text, FL_RESIZE_NONE);
		fl_set_input(memlist[s].start_text, "0");

		memlist[s].total_text = fl_add_input(FL_NORMAL_INPUT,   135, 270,  50,  25, "Total");
		fl_set_input_maxchars(memlist[s].total_text, 8);
		fl_set_object_lstyle(memlist[s].total_text, FL_BOLD_STYLE);
		fl_set_object_gravity(memlist[s].total_text, FL_SouthEast, FL_SouthEast);
		fl_set_object_resize(memlist[s].total_text, FL_RESIZE_NONE);
		fl_set_input(memlist[s].total_text, "100");
		fl_set_input_return(memlist[s].total_text, FL_RETURN_END);
		fl_set_object_callback(memlist[s].total_text, refresh_structure, s);

		memlist[s].refresh_button = fl_add_button(FL_NORMAL_BUTTON,   290, 270,  50,  25, "Refresh");
		fl_set_object_lstyle(memlist[s].refresh_button, FL_BOLD_STYLE);
		fl_set_object_callback(memlist[s].refresh_button, refresh_structure, s);
		fl_set_object_gravity(memlist[s].refresh_button, FL_SouthEast, FL_SouthEast);
		fl_set_object_resize(memlist[s].refresh_button, FL_RESIZE_NONE);

		memlist[s].close_button = fl_add_button(FL_NORMAL_BUTTON,   345, 270,  50,  25, "Close");
		fl_set_object_lstyle(memlist[s].close_button, FL_BOLD_STYLE);
		fl_set_object_callback(memlist[s].close_button, close_structure, s);
		fl_set_object_gravity(memlist[s].close_button, FL_SouthEast, FL_SouthEast);
		fl_set_object_resize(memlist[s].close_button, FL_RESIZE_NONE);

		fl_end_form();
	}
	sprintf(temp_string, "Bochs Frontend - Structure - %s", memlist[s].name);
	fl_show_form(memlist[s].window, FL_PLACE_MOUSE|FL_FREE_SIZE, FL_FULLBORDER, temp_string);
	update_structure(s);
}


void close_structure( FL_OBJECT *obj, long argument ){
	fl_hide_form(memlist[argument].window);
}


void refresh_structure( FL_OBJECT *obj, long argument ){
	if(bochs_running){
		fl_ringbell(0);
		return;
	}
	update_structure((int)argument);
}


void show_memory( FL_OBJECT *obj, long argument ){
	struct memwin_struct *tmp;
	char temp_string[100];

	if((tmp = (struct memwin_struct *)malloc(sizeof(struct memwin_struct))) == NULL) return;

	if(mem_windows == NULL){
		mem_windows = tmp;
		tmp->next = NULL;
	} else {
		tmp->next = mem_windows;
		mem_windows->prev = tmp;
		mem_windows = tmp;
	}
	tmp->prev = NULL;
	tmp->physical = mem_physical;
	tmp->unit_format = mem_type;
	tmp->unit_size = mem_size;
	tmp->units = atoi(fl_get_input(m_size_text));
	tmp->address = strtol(fl_get_input(m_address_text), NULL, 16);
	fl_set_input(m_address_text, NULL);
	fl_set_input(m_size_text, NULL);

	tmp->window = fl_bgn_form(FL_FLAT_BOX, 550, 300);

	tmp->list = fl_add_browser(FL_HOLD_BROWSER,            5,   5, 540, 265, NULL);
	fl_set_object_lstyle(tmp->list, FL_FIXED_STYLE);
	fl_set_object_gravity(tmp->list, FL_NorthWest, FL_SouthEast);
	fl_set_object_resize(tmp->list, FL_RESIZE_ALL);

	tmp->refresh_button = fl_add_button(FL_NORMAL_BUTTON,   440, 270,  50,  25, "Refresh");
	fl_set_object_lstyle(tmp->refresh_button, FL_BOLD_STYLE);
	fl_set_object_callback(tmp->refresh_button, refresh_memory, (long)tmp);
	fl_set_object_gravity(tmp->refresh_button, FL_SouthEast, FL_SouthEast);
	fl_set_object_resize(tmp->refresh_button, FL_RESIZE_NONE);

	tmp->close_button = fl_add_button(FL_NORMAL_BUTTON,   495, 270,  50,  25, "Close");
	fl_set_object_lstyle(tmp->close_button, FL_BOLD_STYLE);
	fl_set_object_callback(tmp->close_button, close_memory, (long)tmp);
	fl_set_object_gravity(tmp->close_button, FL_SouthEast, FL_SouthEast);
	fl_set_object_resize(tmp->close_button, FL_RESIZE_NONE);

	fl_end_form();

	if(mem_physical == 1){
		sprintf(temp_string, "Bochs Frontend - Memory Dump - 0x%.8X physical", tmp->address);
	}else{
		sprintf(temp_string, "Bochs Frontend - Memory Dump - 0x%.8X linear", tmp->address);
	}
	fl_show_form(tmp->window, FL_PLACE_MOUSE|FL_FREE_SIZE, FL_FULLBORDER, temp_string);
	update_memory((long)tmp);
}


void close_memory( FL_OBJECT *obj, long argument ){
	struct memwin_struct *tmp;

	tmp = (struct memwin_struct *)argument;
	fl_hide_form(tmp->window);

	if(tmp->prev == NULL){
		if(tmp->next != NULL){
			mem_windows = tmp->next;
			mem_windows->prev = NULL;
		} else mem_windows = NULL;
	} else {
		tmp->prev->next = tmp->next;
	}

	free(tmp);
}
        
        
void refresh_memory( FL_OBJECT *obj, long argument ){
	if(bochs_running){
		fl_ringbell(0);
		return;
	}
	update_memory(argument);
}


void set_memory_physical( FL_OBJECT *obj, long argument ){

if(argument == 1){
	printf("DEBUG: set memory to physical\n");
}else{
	printf("DEBUG: set memory to linear\n");
}
	mem_physical = (unsigned)argument;
}


void set_memory_type( FL_OBJECT *obj, long argument ){
	if(obj==m_type_hex) mem_type = 'x';
	if(obj==m_type_dec) mem_type = 'd';
	if(obj==m_type_uns) mem_type = 'u';
	if(obj==m_type_oct) mem_type = 'o';
	if(obj==m_type_bin) mem_type = 't';
}


void set_memory_size( FL_OBJECT *obj, long argument ){
	if(obj==m_size_byte)  mem_size = 'b';
	if(obj==m_size_word)  mem_size = 'h';
	if(obj==m_size_dword) mem_size = 'w';
	if(obj==m_size_qword) mem_size = 'g';
}


void set_breakpoint_type( FL_OBJECT *obj, long argument ){
	if(obj==physical_check)	bp_type = BREAKPOINT_PHYSICAL;
	if(obj==linear_check)	bp_type = BREAKPOINT_LINEAR;
	if(obj==virtual_check)	bp_type = BREAKPOINT_VIRTUAL;
}


void add_breakpoint( FL_OBJECT *obj, long argument ){
	const char *addr_string;

	addr_string = fl_get_input(b_address_text);

	switch(bp_type){
		case BREAKPOINT_VIRTUAL:
			fprintf(writepipe, "vb %s\n", addr_string);
			break;
		case BREAKPOINT_LINEAR:
			fprintf(writepipe, "lb %s\n", addr_string);
			break;
		case BREAKPOINT_PHYSICAL:
			fprintf(writepipe, "pb %s\n", addr_string);
			break;
	}
	prompt_read();
	update_breakpoints();
	fl_set_input(b_address_text, NULL);
}


void remove_breakpoint( FL_OBJECT *obj, long argument ){
	int bp;

	bp = fl_get_browser(b_list);
	fprintf(writepipe, "d %d\n", breakpoints[bp-1].number);
	prompt_read();
	update_breakpoints();
}


void clearall_breakpoints( FL_OBJECT *obj, long argument ){
	int x;

	for(x=0; x<30; x++){
		if(breakpoints[x].enabled){
			fprintf(writepipe, "d %d\n", x+1);
			prompt_read();
		} else x = 30;
	}
	update_breakpoints();
}


void instr_go( ){
	bochs_running = 1;

	fl_set_input(i_instruction_text, "   r u n n i n g . . .");
	fl_set_input_color(i_instruction_text, FL_GREEN, FL_BLUE);

	fl_deactivate_object(go_button);
	fl_deactivate_object(step_button);
	fl_deactivate_object(next_button);
	fl_set_object_lcol(go_button, FL_BOTTOM_BCOL);
	fl_set_object_lcol(step_button, FL_BOTTOM_BCOL);
	fl_set_object_lcol(next_button, FL_BOTTOM_BCOL);

	// deactivate breakpoint controls
	fl_deactivate_object(add_button);
	fl_deactivate_object(remove_button);
	fl_deactivate_object(clearall_button);
	fl_deactivate_object(b_address_text);
	fl_set_object_lcol(add_button, FL_BOTTOM_BCOL);
	fl_set_object_lcol(remove_button, FL_BOTTOM_BCOL);
	fl_set_object_lcol(clearall_button, FL_BOTTOM_BCOL);

	// deactivate memory controls
	fl_deactivate_object(m_address_text);
	fl_deactivate_object(m_size_text);
	fl_deactivate_object(dump_button);
	fl_set_object_lcol(dump_button, FL_BOTTOM_BCOL);

	// deactivate structure controls
	fl_deactivate_object(st_list);
	fl_set_object_lcol(st_list, FL_BOTTOM_BCOL);

	fl_activate_object(stop_button);
	fl_set_object_lcol(stop_button, FL_BLACK);

	fprintf(writepipe, "c\n");
	fgetc(readpipe);
	fl_add_io_callback(fileno(readpipe), FL_READ, sigio_handler, NULL);

	fl_addto_browser(i_list, "\t\t\t\t\tGO...");
}


void instr_stop( int sigio ){
	char temp_string[30], buffer[200];
	int bp, bpn;

	fl_remove_io_callback(fileno(readpipe), FL_READ, sigio_handler);
	bochs_running = 0;

	if(!sigio){
		// send ctrl-c to bochs to break out of 'Continue'
		kill(pid, SIGINT);
	} else {
		// read breakpoint info
#ifdef __DEBUG__
printf("STOP: get breakpoint line... ");
#endif
		fgets(buffer, 200, readpipe);
#ifdef __DEBUG__
printf("OK\n");
#endif
		sscanf(buffer, "%*s %*s %i, %*s %*s", &bp);
		if(!next_active){
			for(bpn=0; bp != breakpoints[bpn].number; bpn++);
			switch(breakpoints[bpn].type){
				case BREAKPOINT_VIRTUAL:	sprintf(temp_string, "@bVRT\t0x%X:0x%X\t<--", breakpoints[bpn].segment, breakpoints[bpn].offset);
								break;
				case BREAKPOINT_PHYSICAL:	sprintf(temp_string, "@bPHY\t0x%X\t<--", breakpoints[bpn].offset);
								break;
				case BREAKPOINT_LINEAR:		sprintf(temp_string, "@bLIN\t0x%X\t<--", breakpoints[bpn].offset);
								break;
			}
			fl_replace_browser_line(b_list, bpn+1, temp_string);
			fl_select_browser_line(b_list, bpn+1);
		}
	}
	fl_set_input_color(i_instruction_text, FL_BLACK, FL_BLUE);
	update_xforms();

	if(next_active){
#ifdef __DEBUG__
printf("STOP: delete breakpoint for next... ");
#endif
		fprintf(writepipe, "d %d\n", bp);
		prompt_read();
#ifdef __DEBUG__
printf("OK\n");
#endif
		next_active = 0;
	}

	fl_deactivate_object(stop_button);
	fl_set_object_lcol(stop_button, FL_BOTTOM_BCOL);
	fl_activate_object(go_button);
	fl_activate_object(step_button);
	fl_activate_object(next_button);
	fl_set_object_lcol(go_button, FL_BLACK);
	fl_set_object_lcol(step_button, FL_BLACK);
	fl_set_object_lcol(next_button, FL_BLACK);

        // activate breakpoint controls
        fl_activate_object(add_button);
        fl_activate_object(remove_button);
        fl_activate_object(clearall_button);
        fl_activate_object(b_address_text);
        fl_set_object_lcol(add_button, FL_BLACK);
        fl_set_object_lcol(remove_button, FL_BLACK);
        fl_set_object_lcol(clearall_button, FL_BLACK);

        // activate memory controls
        fl_activate_object(m_address_text);
        fl_activate_object(m_size_text);
        fl_activate_object(dump_button);  
        fl_set_object_lcol(dump_button, FL_BLACK);
        
        // activate structure controls
        fl_activate_object(st_list);
        fl_set_object_lcol(st_list, FL_BLACK);
}


void instr_step( ){
	fprintf(writepipe, "s\n");
	update_xforms();
}


void instr_next( ){
	if(i_description[0] == 'j' || (i_description[0] == 'l' && i_description[2] == 's' && i_description[3] == ' ')){
		instr_step();
		return;
	}

	fprintf(writepipe, "vb 0x%X:0x%X\n", i_virtual_segment, i_virtual_offset + i_size);
#ifdef __DEBUG__
printf("NEXT: vb 0x%X:0x%X\n", i_virtual_segment, i_virtual_offset + i_size);
#endif
	prompt_read();

	next_active = 1;
	bochs_running = 1;

	fl_set_input(i_instruction_text, "   r u n n i n g . . .");
	fl_set_input_color(i_instruction_text, FL_GREEN, FL_BLUE);
        
	fl_deactivate_object(go_button);
	fl_deactivate_object(step_button);
	fl_deactivate_object(next_button);
	fl_set_object_lcol(go_button, FL_BOTTOM_BCOL);
	fl_set_object_lcol(step_button, FL_BOTTOM_BCOL);
	fl_set_object_lcol(next_button, FL_BOTTOM_BCOL);
	fl_activate_object(stop_button);
	fl_set_object_lcol(stop_button, FL_BLACK);

        // deactivate breakpoint controls
        fl_deactivate_object(add_button);
        fl_deactivate_object(remove_button);
        fl_deactivate_object(clearall_button);
        fl_deactivate_object(b_address_text);
        fl_set_object_lcol(add_button, FL_BOTTOM_BCOL);
        fl_set_object_lcol(remove_button, FL_BOTTOM_BCOL);
        fl_set_object_lcol(clearall_button, FL_BOTTOM_BCOL);

        // deactivate memory controls   
        fl_deactivate_object(m_address_text);
        fl_deactivate_object(m_size_text);
        fl_deactivate_object(dump_button);
        fl_set_object_lcol(dump_button, FL_BOTTOM_BCOL);
        
        // deactivate structure controls
        fl_deactivate_object(st_list);
        fl_set_object_lcol(st_list, FL_BOTTOM_BCOL);


	fprintf(writepipe, "c\n");
#ifndef __OLD_BOCHS__
	fgetc(readpipe);
#endif
	fl_add_io_callback(fileno(readpipe), FL_READ, sigio_handler, NULL);

	fl_addto_browser(i_list, "\t\t\t\t\tNEXT...");
}
