#include "popen2.h"


int popen2( char *command, FILE **in, FILE **err)
{
	int ifd[2], efd [2];

	if (in != NULL)
	  pipe(ifd);
	if (err != NULL)
	  pipe(efd);
	pid = fork();
	if (pid == -1) return(0);
	if (pid == 0){
		char *argv[4];
		argv[0] = "sh";
		argv[1] = "-c";
		argv[2] = command;
		argv[3] = 0;
		if (in != NULL)
		  dup2(ifd [0], STDIN_FILENO);
		if (err != NULL)
		  dup2(efd [1], STDERR_FILENO);
		freopen("/dev/null", "a", stdout);
		execv("/bin/sh", argv);
		exit(EXIT_FAILURE);
	} else {
		if (err != NULL)
		  *err = fdopen(efd [0], "r");
		if (in != NULL)
		  *in = fdopen(ifd [1], "w");
        }
	return(1);
}
